<?php

namespace CustomerManagement\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EditCustomerMasterCodeInput StructType
 * @subpackage Structs
 */
class EditCustomerMasterCodeInput extends AbstractStructBase
{
    /**
     * The CustomerID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $CustomerID;
    /**
     * The QueueChangesOnArmedPanel
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $QueueChangesOnArmedPanel;
    /**
     * The NewMasterCode
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $NewMasterCode;
    /**
     * Constructor method for EditCustomerMasterCodeInput
     * @uses EditCustomerMasterCodeInput::setCustomerID()
     * @uses EditCustomerMasterCodeInput::setQueueChangesOnArmedPanel()
     * @uses EditCustomerMasterCodeInput::setNewMasterCode()
     * @param int $customerID
     * @param bool $queueChangesOnArmedPanel
     * @param string $newMasterCode
     */
    public function __construct($customerID = null, $queueChangesOnArmedPanel = null, $newMasterCode = null)
    {
        $this
            ->setCustomerID($customerID)
            ->setQueueChangesOnArmedPanel($queueChangesOnArmedPanel)
            ->setNewMasterCode($newMasterCode);
    }
    /**
     * Get CustomerID value
     * @return int
     */
    public function getCustomerID()
    {
        return $this->CustomerID;
    }
    /**
     * Set CustomerID value
     * @param int $customerID
     * @return \CustomerManagement\StructType\EditCustomerMasterCodeInput
     */
    public function setCustomerID($customerID = null)
    {
        // validation for constraint: int
        if (!is_null($customerID) && !(is_int($customerID) || ctype_digit($customerID))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($customerID, true), gettype($customerID)), __LINE__);
        }
        $this->CustomerID = $customerID;
        return $this;
    }
    /**
     * Get QueueChangesOnArmedPanel value
     * @return bool
     */
    public function getQueueChangesOnArmedPanel()
    {
        return $this->QueueChangesOnArmedPanel;
    }
    /**
     * Set QueueChangesOnArmedPanel value
     * @param bool $queueChangesOnArmedPanel
     * @return \CustomerManagement\StructType\EditCustomerMasterCodeInput
     */
    public function setQueueChangesOnArmedPanel($queueChangesOnArmedPanel = null)
    {
        // validation for constraint: boolean
        if (!is_null($queueChangesOnArmedPanel) && !is_bool($queueChangesOnArmedPanel)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($queueChangesOnArmedPanel, true), gettype($queueChangesOnArmedPanel)), __LINE__);
        }
        $this->QueueChangesOnArmedPanel = $queueChangesOnArmedPanel;
        return $this;
    }
    /**
     * Get NewMasterCode value
     * @return string|null
     */
    public function getNewMasterCode()
    {
        return $this->NewMasterCode;
    }
    /**
     * Set NewMasterCode value
     * @param string $newMasterCode
     * @return \CustomerManagement\StructType\EditCustomerMasterCodeInput
     */
    public function setNewMasterCode($newMasterCode = null)
    {
        // validation for constraint: string
        if (!is_null($newMasterCode) && !is_string($newMasterCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($newMasterCode, true), gettype($newMasterCode)), __LINE__);
        }
        $this->NewMasterCode = $newMasterCode;
        return $this;
    }
}
